"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.entries");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkConditions = void 0;

var _conditionType = require("./shuoCore/conditionType");

var checkConditions = function checkConditions(status, conditions) {
  for (var condition in conditions) {
    switch (condition) {
      case _conditionType.CONDITION.MORE_THAN:
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = conditions[_conditionType.CONDITION.MORE_THAN][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var moreThanProps = _step.value;
            var matched = 0;

            for (var prop in moreThanProps) {
              if (moreThanProps[prop] < status[prop]) {
                matched++;
              }

              if (matched === Object.entries(moreThanProps).length) {
                return true;
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        break;

      case _conditionType.CONDITION.EQUAL:
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = conditions[_conditionType.CONDITION.EQUAL][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var equalProps = _step2.value;
            var _matched = 0;

            for (var _prop in equalProps) {
              if (equalProps[_prop] === status[_prop]) {
                _matched++;
              }

              if (_matched === Object.entries(equalProps).length) {
                return true;
              }
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
              _iterator2["return"]();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        break;

      case _conditionType.CONDITION.LESS_THAN:
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = conditions[_conditionType.CONDITION.LESS_THAN][Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var lessThanProps = _step3.value;
            var _matched2 = 0;

            for (var _prop2 in lessThanProps) {
              if (lessThanProps[_prop2] > status[_prop2]) {
                _matched2++;
              }

              if (_matched2 === Object.entries(lessThanProps).length) {
                return true;
              }
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
              _iterator3["return"]();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }

        break;

      case _conditionType.CONDITION.EXCLUDE:
        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = conditions[_conditionType.CONDITION.EXCLUDE][Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var excludeProps = _step4.value;
            var _matched3 = 0;

            for (var _prop3 in excludeProps) {
              if (status[_prop3]) {
                _matched3++;
              }
            }

            if (_matched3 === 0) {
              return true;
            }
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
              _iterator4["return"]();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }

        break;

      case _conditionType.CONDITION.INCLUDE:
        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = conditions[_conditionType.CONDITION.INCLUDE][Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var includeProps = _step5.value;
            var _matched4 = 0;

            for (var _prop4 in includeProps) {
              if (status[_prop4]) {
                _matched4++;
              }

              if (_matched4 === Object.entries(includeProps).length) {
                return true;
              }
            }
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5["return"] != null) {
              _iterator5["return"]();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }

        break;

      default:
        break;
    }
  }

  return false;
};

exports.checkConditions = checkConditions;