"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.string.includes");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.for-each");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.terrainInfo = void 0;

var _immer = _interopRequireDefault(require("immer"));

var _actionTypes = require("../actions/actionTypes");

var _reactionType = require("../../shuoCore/reactionType");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var initialState = {
  dataSet: []
};

var processReaction = function processReaction(reactions, data) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = reactions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var reaction = _step.value;

      switch (reaction.type) {
        case _reactionType.REACTION.ADD:
          data[reaction.attribute] += reaction.value;
          break;
        // case REACTION.MAYBE_ADD:
        // 	if(randomCheck(seed)){
        // 		data[reaction.props] += reaction.value;
        // 	}
        // 	break;
        //...
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return data;
};

var terrainInfo = function terrainInfo() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  return (0, _immer["default"])(state, function (draft) {
    switch (action.type) {
      case _actionTypes.STORE_CONNECT_REACTOR:
        return action.payload.terrainInfo;
    }

    var type = action.type,
        triggerBy = action.triggerBy,
        triggerTo = action.triggerTo;
    draft.dataSet.forEach(function (data, index) {
      if (data.eventMap[type]) {
        var _data$eventMap$type = data.eventMap[type],
            onlyDirect = _data$eventMap$type.onlyDirect,
            isAny = _data$eventMap$type.isAny,
            types = _data$eventMap$type.types,
            triggers = _data$eventMap$type.triggers,
            blockers = _data$eventMap$type.blockers;

        if (onlyDirect && (triggerTo === null || triggerTo === void 0 ? void 0 : triggerTo.qinId) !== data.qinId || blockers.includes(triggerBy === null || triggerBy === void 0 ? void 0 : triggerBy.qinId) || !isAny && !types.includes(triggerBy === null || triggerBy === void 0 ? void 0 : triggerBy.type) && !triggers.includes(triggerBy === null || triggerBy === void 0 ? void 0 : triggerBy.qinId)) {
          return;
        }
        /* reaction -> e.g: [
        	{type:ADD, attribute:'hp', value: 100 },
        	{type:MAYBE_ADD, attribute:'mp', rate: 0.9 , value: 0 },
        ] */


        var reactions = data.eventMap[type].reactions; // processReaction is a function in common util

        draft.dataSet[index] = processReaction(reactions, data);
      }
    });
  });
};

exports.terrainInfo = terrainInfo;